#ifndef SOLVER_H_INCLUDED

#define SOLVER_H_INCLUDED

#include <stddef.h> //NULL
#include "tables.h"

extern unsigned long long solve(const char* in, const unsigned long long maxSolutions);
extern unsigned long long solve(const int* gridBM, const char* in, const unsigned long long maxSolutions);

extern int solverPlus1(const char* in, char* out, bool redundancyCheck = true, bool unique = false);

extern int solverIsIrreducibleByProbing(char *puz);

extern void digit2bitmap(const char* in, int* out);

#endif // SOLVER_H_INCLUDED
